"""
Cuchulufm is a series of wrappers for bottle, mako and others and construct a simple headless cms.

Copyright (C) 2023 Antonio de la Rosa Caballero

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

from cuchulu.libraries.db.corefields import PhangoField
from cuchulu.libraries import datetime
try:
    from cuchulu.libraries.db.extraforms.dateform import DateForm
except:
    
    class DateForm:
        pass

class DateField(PhangoField):
    """Field for use and save dates in YYYYMMDDHHSS format"""
    
    def __init__(self, name, size=255, required=False):
        
        super().__init__(name, size, required)
        
        self.name_form=DateForm
        
        self.utc=True
        
        self.error_default='Error: Date format invalid'        
        
        self.jtype='string'
        self.jformat='date-time'
    
    def check(self, value):
        
        if self.utc:
        
            value=datetime.local_to_gmt(value)
        
        elif not datetime.obtain_timestamp(value):

            self.error=True
            self.txt_error=self.error_default
            return ''
        
        if value==False:
            
            self.error=True
            self.txt_error=self.error_default
            return ''
        
        return value
    
    def show_formatted(self, value):
        
        return datetime.format_date(value)
